<?php 
/**********************************************************************
*  classes/xcbase.php
*  06-02-12  15:42:00
**********************************************************************/

class XcBase{

   var $_basepath;
   var $_parent;
   var $_localname = '';
   var $_db;
   var $_access;
   var $_users;

   var $ext_services = '';
   var $services_cache = array();


 	function XcBase($parent){
 		$this->debugPrint('Constructor: ('.$parent->_localname.')');
   		$this->_parent = $parent;

   		$this->_basepath = $this->srvFilePath();

   		$this->debugPrint('BasePath: ('.$this->_localname.') '.$this->_basepath);
   		if(file_exists($this->_basepath.'/config.php')) {
      		include($this->_basepath.'/config.php');
      		$this->config = $config;
   		}
 	}



/***********************************kernel/extensions***********************************/

	//   2012-01-25 21:45:07
    /*
        -,  ,   .
    */
    // $servname (string) -  
   function srvFactory($servname) {
     	if($srvDb = $this->srvIsInstalled($servname)) {
        	return $this->srvFactoryNoAccess($servname);
     	} else {
        	return null;
     	}
   }

	//   2012-01-25 21:48:37
    /*
       : **DB, Users  Access**.   .
               .
    
    */
    //  
    function srvInitKernelServices () {
      	$kernel = $this->srvMainKernel();
      	$this->_db = $kernel->srvFactoryNoAccess('DB');
      	$this->_users = $kernel->srvFactoryNoAccess('Users');
      	$this->_access = $kernel->srvFactoryNoAccess('Access');
    }

	//   2012-01-25 21:49:22
    /*
         .
    */
    //  
 	function srvFilePath() {
   		$this->debugPrint('srvFilePath: '.$this->_localname);
   		if($this->_parent!=null) {
     		return $this->_parent->srvFilePath().'/extensions/'.$this->_localname;
   		} else {
     		return realpath(dirname(__FILE__));
   		}
 	}

	//   2012-01-25 21:50:10
    /*
        . :   SpawHtml   ,  **Kernel/SpawHtml**.
    */
    //  
 	function srvAbsolutePath() {
   		if($this->_parent) {
     		return $this->_parent->srvAbsolutePath().'/'.$this->_localname;
   		}
   		return $this->_localname;
 	}

	//   2012-01-25 21:51:15
    /*
        () .   ,    .
    */
    //  
 	function srvMainKernel() {
   		$this->debugPrint('srvMainKernel: '.$_localname);
   		if($this->_parent!=null) {
     		return $this->_parent->srvMainKernel();
   		} else {
     		return $this;
   		}
 	}

	//   2012-01-25 21:53:24
    /*
            .    ,         .
                .
    
    */
    //  
    function srvLoadAll() {
    	if ($this->ext_services=="")
    		$this->ext_services = $this->_db->LoadAll("SELECT * FROM ".$this->_db->config["table_prefix"]."services WHERE parent='".quote($this->srvAbsolutePath())."'");
    	return $this->ext_services;
    }

	//   2012-01-25 21:54:44
    /*
     ,    .             .
    */
    // $name (sring) -  
    function srvIsInstalled($name) {
    	$res = $this->srvLoadAll();
    	if($res!="") 
      		foreach($res as $serv) 
        		if($serv["name"]==$name) return $serv;    
    	return false;
    }

	//   2012-01-25 21:59:03
    /*
       ##$serviceFunction##  ____      .
    */
    // $serviceFunction (string) -   
    // $params (array) -   
    function srvRunAll($serviceFunction, $params) {
      	$cached = $this->_db->LoadSingle("SELECT SQL_NO_CACHE * FROM ".$this->_db->config["table_prefix"]."eventcachecheck WHERE eventname='".quote($serviceFunction)."'");
      	if($cached == "") {
         	$this->srvRunAllMakeCache($serviceFunction, $params);
      	}
      	$result = array();
      	$servs = $this->_db->LoadAll("SELECT * FROM ".$this->_db->config["table_prefix"]."eventcache WHERE eventname='".quote($serviceFunction)."'");
      	if ($servs!=array()) 
         	foreach($servs as $srv) {
             	$sr = $this->srvFactory($srv["name"]);
             	if ($sr) {
               		$resone = $this->srvRunOne($sr,$serviceFunction,$params);
               		if($resone !== null) 
                 		$result[$srv["name"]] = $resone;
               
             	}
         	}      	
      	return $result;
    }

	//   2012-01-25 22:04:02
    /*
           . ,     : ##srvRunOne($serviceSpawHtml, &quot;onInstall&quot;, &#039;&#039;);##
    */
    // $serviceObject (string) - -
    // $serviceFunction (string) -   
    // $params (array) -   
    function srvRunOne($serviceObject,$serviceFunction, $params) {
       	if(method_exists($serviceObject, $serviceFunction)) 
         	return call_user_method($serviceFunction, $serviceObject, $params);
       	else 
         	return null;         	
    }

	//   2012-01-25 22:06:44
    /*
    ,    .    TRUE,  ,     .
           ,    .
    */
    // $params (array) -   
	function onInstall($params) {
		return true;
	}

	//   2012-01-25 22:07:22
    /*
    ,    .    TRUE,  ,     .
           ,    .
    */
    // $params (array) -   
	function onUninstall($params) {
		return true;
	}

	//   2012-01-25 22:08:52
    /*
    ,   .     TRUE.
    */
    // $serviceName (sring) -  
    // $params (array) -   
    function srvInstallService($serviceName, $params) {
     	if($this->srvIsInstalled($serviceName)) {
        	return false;
     	} else {
        	$srvObject = $this->srvFactoryNoAccess($serviceName);
        	if($this->srvRunOne($srvObject, 'onInstall', $params)) {
           		$this->_db->Query('INSERT INTO '.$this->_db->config["table_prefix"]."services SET name='".quote($serviceName)."'");
           		return true;
        	} else 
           		return false;        
     	}
    }

	//   2012-01-25 22:09:51
    /*
    ,   .     TRUE.
    */
    // $serviceName (sring) -  
    // $params (array) -   
    function srvUninstallService($serviceName, $params) {
     	if(!$this->srvIsInstalled($serviceName)) {
        	return false;
     	} else {
        	$srvObject = $this->srvFactoryNoAccess($serviceName);
       	 	$this->srvRunOne($srvObject, 'onUninstall', $params);
        	$this->_db->Query("DELETE FROM ".$this->_db->config["table_prefix"]."services WHERE name='".quote($serviceName)."'");
        	return true;
     	}
    }

	//   2012-01-31 17:52:43
    /*
    !!?!!
    $resone = $this-&gt;srvRunOneFake($sr,$serviceFunction,$params)true;
    */
    // $serviceFunction (string) -   
    // $params (array) -   
    function srvRunAllMakeCache($serviceFunction, $params) {
      	$servs = $this->srvLoadAll();
      	if ($servs!=array()) 
         	foreach($servs as $srv) {
             	$sr = $this->srvFactory($srv["name"]);
             	if ($sr) {
               		$resone = /*$this->srvRunOneFake($sr,$serviceFunction,$params*/true;
               		if($resone) 
                 		$this->_db->insertInto("eventcache", array("eventname" => $serviceFunction, "name" => $srv["name"]));
               
             	}
         	}      	
      	$this->_db->insertInto("eventcachecheck", array("eventname" => $serviceFunction));
    }

	//   2012-02-05 20:05:58
    /*
      -   .            ,   . .., ** -  Singleton**.
    
    */
    // $servname (string) -  
    function srvFactoryNoAccess($servname) {
       	$this->debugPrint('srvFactoryNoAccess: '.$this->_localname.' serv '.$servname);
       	$res = $this->service_cache[$servname];
       	if ($res) {  
          	$this->debugPrint('srvFactoryNoAccess: '.$this->_localname.' USE CACHE serv '.$servname);
          	return $res;
       	} else {    
         	if (file_exists($this->_basepath.'/../extensions/' . $servname . '/'.$servname.'.php')) {
         		if (require_once($this->_basepath.'/../extensions/' . $servname . '/'.$servname.'.php')) {
             		$classname = 'Service_'.$servname;
             		$serv = new $classname($this);
	             	$this->service_cache[$servname] = &$serv;
	             	$serv->srvInitKernelServices();
	             	return $serv;
          		} else {
             		$this->debugPrint('Service '.$servname.' class not found');
             		return null;
         		}
         	} else {
             	return null;
         	}
       	}  
    }


/***********************************kernel/config***********************************/

	//   2012-01-25 21:52:32
    /*
     ,   .
    */
    // $name (string) -  
 	function GetConfigValue($name) { 
 		return isset( $this->config[$name] ) ? $this->config[$name] : ''; 
 	}


/***********************************kernel/system***********************************/

	//   2012-01-25 22:05:36
    /*
        .    -  .
    */
    // $txt (string) -   
    function debugPrint($txt) {
     	/*
     	$fd = fopen('debug.txt','a');
     	fwrite($fd,'('.$this->_localname.'): '.$txt."\n");
     	fclose($fd);
     	*/
    }

}

?> 
