<?php

function myLocation()
   {
      list($url, ) = explode("?", $_SERVER["REQUEST_URI"]);
      return $url;
   }

// Draws a tick or cross next to a result
function output_image($ok)
   {
      GLOBAL $lang;
      return "<img src=\"".myLocation()."setup/images/".($ok ? "tick" : "cross").".png\" width=\"20\" height=\"20\" alt=\"".($ok ? $lang["OK"] : $lang["Problem"])."\" title=\"".($ok ? $lang["OK"] : $lang["Problem"])."\" class=\"tickcross\" />";
   }

function is__writable($path)
   {
      if($path{strlen($path)-1}=='/') // recursively return a temporary file path
         return is__writable($path.uniqid(mt_rand()).'.tmp');
      else if (is_dir($path))
         return is__writable($path.'/'.uniqid(mt_rand()).'.tmp');
      // check tmp file for read/write capabilities
      $rm = file_exists($path);
      $f = @fopen($path, 'a');
      if ($f===false)
         return false;
      fclose($f);
      if(!$rm)
         unlink($path);
      return true;
   }

function test($text, $condition, $errorText = "")
   {
      GLOBAL $lang;
      print("            <li>".$text." - ".output_image($condition));

      if(!$condition)
         {
            if($errorText)
               {
                  print("<ul class=\"install_error\"><li>".$errorText."</li></ul>");
               }

            print("</li>\n");
            return false;
         }

      print("</li>\n");
      return true;
   }

// Fetch Configuration
$config = $_POST["config"];
$config2 = array_merge((array)$wakkaConfig, (array)$_POST["config"]);

if (!isset($config["language"]) || !@file_exists("setup/lang/installer.".$config["language"].".php")) $config["language"] = "ru";
require_once("setup/lang/installer.".$config["language"].".php");
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $config["language"]; ?>" lang="<?php echo $config["language"]; ?>">
   <head>
      <title><?php echo $lang["Title"];?></title>
      <meta http-equiv="Content-Type" content="text/html; charset=<?php echo $lang["Charset"]; ?>" />
      <link rel="stylesheet" href="<?php echo myLocation() ?>setup/css/installer.css" type="text/css" />
   </head>
   <body>
      <div class="installer">
         <h1><?php echo $lang["Title"];?></h1><h1 class="white">&nbsp;:&nbsp;</h1><h1><?php echo $lang[$installAction]; ?></h1>
         <ul class="menu">
            <li class="<?php echo $installAction == 'lang' ? 'current' : 'item'; ?>"><?php echo $lang["Lang"]; ?></li>
            <li>&gt;</li>
            <li class="<?php echo $installAction == 'version-check' ? 'current' : 'item'; ?>"><?php echo $lang["version-check"]; ?></li>
            <li>&gt;</li>
            <li class="<?php echo $installAction == 'site-config' ? 'current' : 'item'; ?>"><?php echo $lang["site-config"]; ?></li>
            <li>&gt;</li>
<?php
   if(!$wakkaConfig["wakka_version"])
      {
?>
            <li class="<?php echo $installAction == 'database-config' ? 'current' : 'item'; ?>"><?php echo $lang["database-config"]; ?></li>
            <li>&gt;</li>
<?php
         }
?>
            <li class="<?php echo $installAction == 'database-install' ? 'current' : 'item'; ?>"><?php echo $lang["database-install"]; ?></li>
            <li>&gt;</li>
            <li class="<?php echo $installAction == 'write-config' ? 'current' : 'item'; ?>"><?php echo $lang["write-config"]; ?></li>
         </ul>
         <div class="fake_hr"><hr /></div>
